#ifndef SOFTWAREGENERATOR_SEEN
#define SOFTWAREGENERATOR_SEEN


#include "abstractSoftware.h"

class softwareGenerator : public abstractSoftware
{
 protected : 
  
  bool beamFromGenerator(string beamFileName, string workingDir, vector<double>& centroid, bareParticle& refPart,vector<bareParticle>& particles, vector<bareParticle>& passiveParticles );

  string elementsData(const vector< pair<string, vector<string> > >& donnees) const;
 
  string rfgunData(const vector< pair<string, vector<string> > >& donnees) const;

 public : 
  
  softwareGenerator();  
  softwareGenerator(string inputFileName, sectionToExecute*);

  virtual ~softwareGenerator() {;}

  virtual bool createInputFile(particleBeam* beamBefore, string workingDir);
  virtual bool execute(string workingDir);
  virtual bool buildBeamAfterElements(string workingDir);

  inline string getColor() {
    return "#a3c0ed";
  }
};
#endif
